function drawHud()
	drawPlayerPresentStack()
	drawDonconSatisfactionMeter()
	drawCursor()
	drawGameOver()
end

function drawPlayerPresentStack()
	for i, p in pairs(player.presents) do
		lg.setColor(1,1,1)
		lg.draw(p.img,640/2 + 108 + (i*21),333)
	end
end

function drawCursor()
	lg.setColor(1,1,1)
	lg.draw(i_crosshair, mouse.x,mouse.y, 0, 1,1, i_crosshair:getWidth()/2,i_crosshair:getHeight()/2)
end

function drawGameOver()
	if game.state == "gameover" then
		lg.setColor(0,0,0, 0.65)
		lg.rectangle("fill", 0,0, 640,360)
		
		lg.setColor(215/255,45/255,45/255)
		lg.print("Game Over", 30,30, 0,0.04)
		
		lg.setColor(170/255,20/255,60/255)
		lg.print('The mighty DONCON is not pleased...', 30, 72, 0, 0.02)
		
		lg.setColor(219/255,244/255,1)
		lg.print('You survived for '..math.floor(player.timer)..' seconds!', 30, 280, 0, 0.02)
		
		lg.setColor(65/255,205/255,115/255)
		lg.print('Press "R" to restart', 30, 310 - math.sin(lt.getTime()*3)*5, 0, 0.03)
	end
end

function drawDonconSatisfactionMeter()
	local x = 640/2
	local y = 345
	local width = 250
	local height = 10
	local lineHeight = 12
	local lineWidth = 1
	local shadowOffset = 2

	lg.setBlendMode("subtract")
	lg.setColor(1,1,1, 0.2)
	lg.rectangle('fill', x - (width/2) + shadowOffset, y - (height/2) + shadowOffset, width,height)
	lg.rectangle('fill', x - (width/2) + shadowOffset, y - (lineHeight/2) + shadowOffset, 1,lineHeight)
	lg.rectangle('fill', x + (width/2) + shadowOffset, y - (lineHeight/2) + shadowOffset, 1,lineHeight)
	lg.setBlendMode("alpha")
	
	local r,g,b = 0,0,0
	if doncon.satisfaction > 0.66 then r,g,b = 115/255,1,115/255
	elseif doncon.satisfaction > 0.33 then r,g,b = 1,230/255,90/255
	else r,g,b = 215/255,45/255,45/255 end
	lg.setColor(r,g,b)
	lg.rectangle('fill', x - (width/2), y - (height/2), width * doncon.satisfaction,height)

	lg.setColor(1,1,1)
	lg.rectangle('fill', x - (width/2), y - (lineHeight/2), 1,lineHeight)
	lg.rectangle('fill', x + (width/2), y - (lineHeight/2), 1,lineHeight)
	
	if doncon.satisfaction < 0.33 then
		if math.sin(lt.getTime() * 10) > 0 then
			lg.setColor(215/255,45/255,45/255)
		else
			lg.setColor(219/255,244/255,1)
		end
		lg.print("!", x - (width/2) - 16,y - height - 6, 0,0.031)
	end
end