function drawWorld()
	lg.setBackgroundColor(9/255,10/255,20/255)

	drawPlatform()
	drawPickups()
	drawProjectiles()
	drawPlayer()
	drawDoncon()
end

function drawPlayer()
	lg.setBlendMode("subtract")
	lg.setColor(1,1,1, 0.3)
	draw(i_shadow, player.x,player.y, 0, 1,1, i_shadow:getWidth()/2, i_shadow:getHeight()/2)
	lg.setBlendMode("alpha")
	
	local img = i_player
	if lk.isDown("w","s","a","d") then
		img = play(a_playerRun)
	else
		img = play(a_playerIdle)
	end
	
	if game.state == "gameover" then
		img = i_playerDead
		player.stunTimer = 0
	end
	
	local flip = -1
	if player.x < mouse.x + camera.x and game.state ~= "gameover" then
		flip = 1
	end
	
	if player.invulTimer > 0 then
		local c = math.sin(lt.getTime() * 30) / 2 + 0.5
		lg.setColor(1,1,1, c)
	else
		lg.setColor(1,1,1)
	end
	draw(img, player.x,player.y, 0, flip,1, i_player:getWidth()/2, i_player:getHeight())
end

function drawDoncon()
	local timer = lt.getTime()
	lg.setColor(1,1,1)
	draw(i_doncon, doncon.x,doncon.y + (math.sin(timer*2.5)*3), 0, 1 + (doncon.hitTimer * doncon.hitMult),1 - (doncon.hitTimer * doncon.hitMult), i_doncon:getWidth()/2,i_doncon:getHeight()/2)
end

function drawPlatform()
	lg.setColor(1,1,1)
	draw(i_platformBg, 640/2,360/2, 0, 1,1, i_platformBg:getWidth()/2,i_platformBg:getHeight()/2, 0.5)
	lg.setColor(1,1,1)
	draw(i_platform, 640/2,360/2, 0, 1,1, i_platform:getWidth()/2,i_platform:getHeight()/2)
end

function drawProjectiles()
	for i, p in pairs(projectiles) do
		p.rot = p.rot or 0
		p.rotSpeed = p.rotSpeed or 0
		p.rot = p.rot + (p.rotSpeed*hdt)
		
		local projectileGlowMult = 1.4
		local size = p.drawSize or p.size
		size = size * (1-p.startTimer)
		local angle = p.drawAngle or p.angle
		local timer = lt.getTime()
	
		lg.setColor(1,1,1)
		draw(p.img, p.x,p.y, angle+math.pi+p.rot, size/p.img:getWidth(),size/p.img:getHeight(), p.img:getWidth()/2,p.img:getHeight()/2)
		
		lg.setBlendMode("add")
		lg.setColor(1,1,1, 0.2)
		draw(p.shineImg, p.x,p.y, angle+math.pi+p.rot, size / p.shineImg:getWidth() * projectileGlowMult + (math.sin(timer*10)*0.015),size / p.shineImg:getHeight() * projectileGlowMult + (math.cos(timer*10)*0.015), p.shineImg:getWidth()/2,p.shineImg:getHeight()/2)
		lg.setBlendMode("alpha")
	end
end

function drawPickups()
	for i, p in pairs(pickups) do
		local f = 20
	
		lg.setBlendMode("subtract")
		lg.setColor(1,1,1, 0.3)
		draw(i_shadow, p.x,p.y, 0, 1-p.spawnTime^f,1-p.spawnTime^f, i_shadow:getWidth()/2,i_shadow:getHeight()/2)
		lg.setBlendMode("alpha")
		
		lg.setColor(1,1,1)
		draw(p.img, p.x,p.y, 0, 1-p.spawnTime^f,1-p.spawnTime^f, p.img:getWidth()/2,p.img:getHeight())
	end
end

function draw(img, x,y,r,sx,sy,ox,oy, paralax)
	x = x or 0
	y = y or 0
	r = r or 0
	sx = sx or 1
	sy = sy or 1
	ox = ox or 0
	oy = oy or 0
	paralax = paralax or 1

	lg.draw(img, math.floor(x - camera.x*paralax + 0.5),math.floor(y - camera.y*paralax + 0.5),r,sx,sy,math.floor(ox + 0.5),math.floor(oy + 0.5))
end