function loadFunctions()	
	function math.dist(x1,y1,x2,y2)
		return ((x2-x1)^2+(y2-y1)^2)^0.5 
	end
	
	function math.dist3D(x1,y1,z1, x2,y2,z2)
		return ((x2-x1)^2+(y2-y1)^2+(z2-z1)^2)^0.5
	end
	
	function math.angle(x1,y1, x2,y2)
		return math.atan2(y2-y1, x2-x1)
	end
	
	function math.most(x,maximum)
		if x > maximum then return maximum else return x end
	end
	function math.least(x,minimum)
		if x < minimum then return minimum else return x end
	end
	
	function lerp(a,b,t) return (1-t)*a + t*b end
	
	function collision(x1,y1,w1,h1, x2,y2,w2,h2)
		return x1 < x2+w2 and
		   y1 < y2+h2 and
		   x2 < x1+w1 and
		   y2 < y1+h1
	end
	
	function getTableSize(t)
		local c=0
		for i, o in ipairs(t) do
			c=c+1
		end
		return c
	end
	
	function doesTableContain(t,o)
		local returnValue = false
		for i, a in ipairs(t) do
			if a == o then returnValue = true end
		end
		return returnValue
	end
	
	function shuffle(tbl)
		for i = #tbl, 2, -1 do
			local j = math.random(i)
			tbl[i], tbl[j] = tbl[j], tbl[i]
		end
		return tbl
	end
	
	function playS(sound,volume,pitch,looping)
		pitch = pitch or 1
		looping = looping or false

		s = sound:clone()
		s:setVolume(volume)
		s:setPitch(pitch)
		s:setLooping(looping)
		
		love.audio.play(s)

	end
end