function updatePlayer()
	movePlayer()
	keepPlayerInCircle()
	collidePlayerWithPickups()
	setCameraPos()
end

function movePlayer()
	player.timer = player.timer + hdt

	local angle = 0
	if lk.isDown("w") then
		angle = math.rad(270)
	end
	if lk.isDown("s") then
		angle = math.rad(90)
	end
	if lk.isDown("a") then
		angle = math.rad(180)
	end
	if lk.isDown("d") then
		angle = 0
	end
	
	if lk.isDown("w") and lk.isDown("d") then
		angle = math.rad(270 + 360) / 2
	end
	if lk.isDown("w") and lk.isDown("a") then
		angle = math.rad(270 + 180) / 2
	end
	if lk.isDown("s") and lk.isDown("d") then
		angle = math.rad(90) / 2
	end
	if lk.isDown("s") and lk.isDown("a") then
		angle = math.rad(90 + 180) / 2
	end
	
	if lk.isDown("w","s","a","d") and player.stunTimer <= 0 then
		if lk.isDown("a") and lk.isDown("d") then else 
			player.x = player.x + (math.cos(angle) * player.speed * hdt)
		end
		if lk.isDown("w") and lk.isDown("s") then else 
			player.y = player.y + (math.sin(angle) * player.speed * hdt)
		end
	end
end

function keepPlayerInCircle()
	if math.dist(player.x, player.y, 640/2,360/2) > world.r then
		local angle = math.angle(640/2,360/2, player.x, player.y)
		local dist = world.r
		
		player.x = 640/2 + (math.cos(angle) * dist)
		player.y = 360/2 + (math.sin(angle) * dist)
	end
end

function collidePlayerWithPickups()
	for i, p in pairs(pickups) do
		if collision(player.x - (player.w/2), player.y - (player.h/2), player.w,player.h, p.x - (p.size/2), p.y - (p.size/2), p.size,p.size) then
			table.insert(player.presents, p)
			table.remove(pickups, i)
			playS(s_pickup,game.soundVolume)
		end
	end
end

function setCameraPos()
	local dist = math.dist(player.x,player.y - player.mouseOffsetY, mouse.x + camera.x,mouse.y + camera.y) / 3
	local angle = math.angle(player.x,player.y - player.mouseOffsetY, mouse.x + camera.x,mouse.y + camera.y)
	
	camera.x = player.x - (640 / 2) + math.cos(angle) * dist
	camera.y = player.y - (360 / 2) + math.sin(angle) * dist
end


function love.mousepressed(x, y, button, istouch)
	if getTableSize(player.presents) > 0 then
		addProjectileFromPresent(player.x,player.y - player.mouseOffsetY, math.angle(player.x,player.y - player.mouseOffsetY, mouse.x + camera.x,mouse.y + camera.y) + math.pi/2, player.presents[1])
		table.remove(player.presents, 1)
		playS(s_throw, game.soundVolume)
	end
end

function love.keypressed(key, unicode)
	if key == "f" then
		game.fullscreen = not game.fullscreen
		lw.setFullscreen(game.fullscreen)
	end
	if key == "g" then
		game.grabbed = not game.grabbed
		lm.setGrabbed(game.grabbed)
	end
end