function updateProjectiles()
	moveProjectiles()
	updateProjectileTimers()
	presentToDonconCollision()
	projectileToPlayerCollision()
end

function moveProjectiles()
	for i, p in pairs(projectiles) do
		if p.startTimer <= 0 then
			p.x = p.x + (math.cos(p.angle) * p.speed * hdt)
			p.y = p.y + (math.sin(p.angle) * p.speed * hdt)
		end
	end
end

function updateProjectileTimers()
	for i, p in pairs(projectiles) do
		p.startTimer = math.least(p.startTimer - hdt, 0)
		p.lifeSpan = p.lifeSpan - hdt
		
		if p.lifeSpan <= 0 then
			table.remove(projectiles, i)
		end
	end
end

function presentToDonconCollision()
	for i, p in pairs(projectiles) do
		if p.present and collision(doncon.x - (doncon.w/2),doncon.y - (doncon.h/2), doncon.w,doncon.h, p.x - (p.size/2),p.y - (p.size/2), p.size,p.size) then
			doncon.satisfaction = doncon.satisfaction + p.value
			if math.random(1,2) == 1 then doncon.hitTimer = 1 else doncon.hitTimer = -1 end
			table.remove(projectiles, i)
			playS(s_eat, game.soundVolume)
			
			screen:zoom(0.95)
			screen:shake(14)
			lt.sleep(1/60)
		end
	end
end

function projectileToPlayerCollision()
	local maxStun = 0.75
	local maxInvul = 1.4
	
	for i, p in pairs(projectiles) do
		local yOffset = 4
		if not p.present and collision(player.x - player.w/2,player.y - player.h/2 - yOffset, player.w,player.h, p.x - (p.cSize/2),p.y - (p.cSize/2), p.cSize,p.cSize) and player.invulTimer <= 0 then
			player.stunTimer = maxStun
			player.invulTimer = maxInvul
			playS(s_hit, game.soundVolume*2)
			
			if getTableSize(player.presents) > 0 then
				table.remove(player.presents, getTableSize(player.presents))
			end
			
			screen:shake(20)
			screen:setRotation(math.rad(25))
			lt.sleep(1/30)
		end
	end
	
	player.stunTimer = player.stunTimer - hdt
	player.invulTimer = player.invulTimer - hdt
end


function addProjectile(x,y,angle, id)
	local size = 0
	local speed = 0
	local present = false
	local img = i_projectile1
	local shineImg = i_projectile1Shine
	local lifeSpan = 10
	
	if id == 1 then
		size = 20
		cSize = 16
		speed = 150
		present = false
		img = i_projectile1
		shineImg = i_projectile1Shine
	end
	if id == 2 then
		size = 20
		cSize = 16
		speed = 280
		present = false
		img = i_projectile3
		shineImg = i_projectile3Shine
	end
	if id == 3 then
		size = 40
		cSize = 40
		speed = 80
		present = false
		img = i_projectile2
		shineImg = i_projectile2Shine
	end
	
	table.insert(projectiles, {x=x,y=y, angle=angle, img=img,shineImg=shineImg,speed=speed, present=present,size=size,startTimer = 1, lifeSpan=lifeSpan, cSize = cSize})
end

function addProjectileFromPresent(x,y,angle, present)
	table.insert(projectiles, {x=x,y=y, angle=angle - math.rad(90), img=present.img,shineImg=present.img,speed=speed, present=true,size=present.size,cSize=present.size, drawSize=20, speed = present.speed, drawAngle = math.rad(math.random(0,360)), rotSpeed = math.rad(math.random(-300,300)), startTimer = 0, lifeSpan = 10, value = present.value})
end