function updateWorld()
	addPresents()
	addProjectiles()
	updateEvents()
end

function addPresents()
	if world.presentTimer <= 0 then
		world.presentTimer = getTableSize(pickups) * math.random(10,20)/20
		
		local dist = math.random(world.r / 8,world.r - 10)
		local angle = math.rad(math.random(0,360))
		addPickup(math.floor(math.cos(angle) * dist + 640/2), math.floor(math.sin(angle) * dist + 360/2), math.random(1,3))
	else
		world.presentTimer = world.presentTimer - hdt
	end
end

function addProjectiles()
	if world.eventTimer <= 0 then
		setEvent()
	end
	world.eventTimer = world.eventTimer - hdt
end
function setEvent()
	world.event = 3
	while world.event == world.previousEvent do world.event = math.random(1,3) end
	world.previousEvent = world.event
	world.fast = math.random(1,2)
	
	if world.event == 1 then
		world.eventTimer = 8
	end
	
	if world.event == 2 then
		world.eventTimer = 8
	end
	
	if world.event == 3 then
		world.eventTimer = 8
	end
end

function updateEvents()
	world.eventIntensity = world.eventIntensity + (world.eventIntensityChangeRate * hdt)

	if world.event == 1 then
		local turnSpeed = math.rad(120)
		local maxShootTimer = 0.2
		
		world.shootAngle = world.shootAngle or 0
		world.shootAngle = world.shootAngle + (turnSpeed*hdt)
		world.shootTimer = world.shootTimer or 0
		world.shootTimer = world.shootTimer + hdt
		
		if world.shootTimer * world.eventIntensity / world.fast > maxShootTimer then
			addProjectile(math.cos(world.shootAngle) * world.r + 640/2, math.sin(world.shootAngle) * world.r + 360/2, world.shootAngle + math.pi, world.fast)
			world.shootTimer = 0
		end
	end
	
	if world.event == 2 then
		world.shootTimer = world.shootTimer or 0
		world.shootTimer = world.shootTimer + hdt
		local maxTimer = 2
	
		if world.shootTimer * world.eventIntensity / world.fast > maxTimer then
			local jump = 25
			local rows = 20
			local flip = true
			for i = 360/2 - jump*rows/2, 360/2  + jump*rows/2, jump do
				if flip then
					addProjectile(640/2 + world.r, i, math.pi,world.fast)
				else
					addProjectile(640/2 - world.r, i, 0,world.fast)
				end
				flip = not flip
			end
			
			world.shootTimer = 0
		end
	end
	
	if world.event == 3 then
		world.shootTimer = world.shootTimer or 0
		world.shootTimer = world.shootTimer + hdt
		
		local maxTimer = 1.8
		local angle = math.random(0,360)
		local x = 0
		local y = 0
		local bits = 30
		
		if world.shootTimer * world.eventIntensity / world.fast > maxTimer then
			angle = angle + math.rad(math.random(50,260))
			x = 640/2 + world.r * math.cos(angle)
			y = 360/2 + world.r * math.sin(angle)
			
			for i = 1, bits do
				addProjectile(x,y, math.rad(i / bits * 360), world.fast)
			end
			world.shootTimer = 0
		end
	end
	
end