lg = love.graphics
la = love.audio
lk = love.keyboard
lm = love.mouse
lt = love.timer
lw = love.window

function love.load()
	lg.setDefaultFilter("nearest","nearest")

	require "libs/maid64"
	screen = require "libs/shack"
	require "bin/animationsystem"
	
	require "bin/player"
	require "bin/projectiles"
	require "bin/pickups"
	require "bin/world"
	require "bin/doncon"
	require "bin/assets"
	require "bin/gameover"
	require "bin/functions"
	require "bin/drawWorld"
	require "bin/drawHud"
	
	maid64.setup(640,360)
	
	loadFunctions()
	loadAssets()
	
	player = {x=640/2 - 10,y=720/2 - 10, w=15,h=6, speed = 200, presents = {}, mouseOffsetY = 10, stunTimer = 0, invulTimer = 0, timer = 0}
	doncon = {x=640/2,y=-170, w=141, h=136, satisfaction = 1, satisfactionChangeRate = 0.035, satisfactionChangeRateIncreaseRate = 0.0001, hitTimer = 0, hitMult = 0.12}
	camera = {x=0,y=0}
	world = {r = 250, presentTimer = 0, eventTimer = 0, eventIntensity = 0.6, eventIntensityChangeRate = 0.01}
	game = {fullscreen = false, state = "playing", grabbed = true, soundVolume = 1, musicVolume = 0.3}
	projectiles = {}
	pickups = {}
	
	lm.setVisible(false)
	lm.setGrabbed(true)
	--playS(s_music, game.musicVolume,1,true)
	
	screen:setDimensions(640,360)
	
	resetGame()
end

function love.update(dt)
	hdt = dt
	mouse = {x = math.floor(lm.getX()/2 + 0.5), y = math.floor(lm.getY()/2 + 0.5)}
	if mouse.x > 640 then lm.setX(1280) end
	if mouse.y > 360 then lm.setY(720) end
	
	if game.state == "playing" then
		updateWorld()
		updatePlayer()
		updateProjectiles()
		updatePickups()
		updateDoncon()
	elseif game.state == "gameover" then
		updateGameOverScreen()
	end
	
	screen:update(dt)
	
	if lk.isDown("escape") then love.event.quit() end
end

function love.draw(dt)
	screen:apply()

	maid64.start()--starts the maid64 process
	
	drawWorld()
	drawHud()
	
	lg.setColor(1,1,1)
	maid64.finish()--finishes the maid64 process
end

function love.resize(w, h)
    -- this is used to resize the screen correctly
    maid64.resize(w, h)
end